#!/usr/bin/perl

# This is a sample Script file
# It does not much:
#   * Loading configuration
#   * including header.htmlfooter.html
#   * and showing a message to the user.
# That's all.

use File::HomeDir;
use Config::Simple;
use warnings;
use strict;
use CGI::Carp qw(fatalsToBrowser);
use CGI qw/:standard/;
use Cwd 'abs_path';
no strict "refs"; # we need it for template system

my  $home = File::HomeDir->my_home;
my  $lang;
my  $installfolder;
my  $cfg;
our  $psubfolder;
our $helptext;
our $template_title;

my %query;
my $namef;
my $value;
my $relaynumber;
my $command;
my $offdelay;
my $output;
my $pcfg;
my $gpiorelay1;
my $gpiorelay2;
my $gpiorelay3;
my $gpiorelay4;
our $host;
our $loginname;

# Figure out in which subfolder we are installed
$psubfolder = abs_path($0);
$psubfolder =~ s/(.*)\/(.*)\/(.*)$/$2/g;

# Init Language
# Clean up lang variable
$lang =~ tr/a-z//cd;
$lang = substr($lang,0,2);

# Read Settings
$cfg             = new Config::Simple("$home/config/system/general.cfg");
$installfolder   = $cfg->param("BASE.INSTALLFOLDER");
$lang            = $cfg->param("BASE.LANG");
$pcfg          = new Config::Simple("$home/config/plugins/$psubfolder/relayplugin.cfg");


# Save settings
if ( param('savesettings') ) {

  #set GPIO1
  $gpiorelay1 = param('gpiorelay1');
  quotemeta($gpiorelay1);
  $pcfg->param("gpiopins.relay1", "$gpiorelay1");
  
  #set GPIO2
  $gpiorelay2 = param('gpiorelay2');
  quotemeta($gpiorelay2);
  $pcfg->param("gpiopins.relay2", "$gpiorelay2");
  
  #set GPIO3
  $gpiorelay3 = param('gpiorelay3');
  quotemeta($gpiorelay3);
  $pcfg->param("gpiopins.relay3", "$gpiorelay3");
  
  #set GPIO4
  $gpiorelay4 = param('gpiorelay4');
  quotemeta($gpiorelay4);
  $pcfg->param("gpiopins.relay4", "$gpiorelay4");

  # Save Config
  $pcfg->save();
}

# Config auslesen
$gpiorelay1      = $pcfg->param("gpiopins.relay1");
$gpiorelay2      = $pcfg->param("gpiopins.relay2");
$gpiorelay3      = $pcfg->param("gpiopins.relay3");
$gpiorelay4      = $pcfg->param("gpiopins.relay4");

# Some vars for the template
$host = "$ENV{HTTP_HOST}";
$loginname = "$ENV{REMOTE_USER}";


# If there's no file in our language, use german as default
if (!-e "$installfolder/templates/plugins/$psubfolder/$lang/main.html") {
	$lang = "de";
}


# Select GPIO Pin Relay 1
if ( $gpiorelay1 eq "4" ) { our $selectedrelay1pin4 = "selected=selected" }
elsif ( $gpiorelay1 eq "17" ) { our $selectedrelay1pin17 = "selected=selected" }
elsif ( $gpiorelay1 eq "18" ) { our $selectedrelay1pin18 = "selected=selected" }
elsif ( $gpiorelay1 eq "21" ) { our $selectedrelay1pin21 = "selected=selected" }
elsif ( $gpiorelay1 eq "22" ) { our $selectedrelay1pin22 = "selected=selected" }
elsif ( $gpiorelay1 eq "23" ) { our $selectedrelay1pin23 = "selected=selected" }
elsif ( $gpiorelay1 eq "24" ) { our $selectedrelay1pin24 = "selected=selected" }
elsif ( $gpiorelay1 eq "25" ) { our $selectedrelay1pin25 = "selected=selected" }


# Select GPIO Pin Relay 2
if ( $gpiorelay2 eq "4" ) { our $selectedrelay2pin4 = "selected=selected" }
elsif ( $gpiorelay2 eq "17" ) { our $selectedrelay2pin17 = "selected=selected" }
elsif ( $gpiorelay2 eq "18" ) { our $selectedrelay2pin18 = "selected=selected" }
elsif ( $gpiorelay2 eq "21" ) { our $selectedrelay2pin21 = "selected=selected" }
elsif ( $gpiorelay2 eq "22" ) { our $selectedrelay2pin22 = "selected=selected" }
elsif ( $gpiorelay2 eq "23" ) { our $selectedrelay2pin23 = "selected=selected" }
elsif ( $gpiorelay2 eq "24" ) { our $selectedrelay2pin24 = "selected=selected" }
elsif ( $gpiorelay2 eq "25" ) { our $selectedrelay2pin25 = "selected=selected" }

# Select GPIO Pin Relay 3
if ( $gpiorelay3 eq "4" ) { our $selectedrelay3pin4 = "selected=selected" }
elsif ( $gpiorelay3 eq "17" ) { our $selectedrelay3pin17 = "selected=selected" }
elsif ( $gpiorelay3 eq "18" ) { our $selectedrelay3pin18 = "selected=selected" }
elsif ( $gpiorelay3 eq "21" ) { our $selectedrelay3pin21 = "selected=selected" }
elsif ( $gpiorelay3 eq "22" ) { our $selectedrelay3pin22 = "selected=selected" }
elsif ( $gpiorelay3 eq "23" ) { our $selectedrelay3pin23 = "selected=selected" }
elsif ( $gpiorelay3 eq "24" ) { our $selectedrelay3pin24 = "selected=selected" }
elsif ( $gpiorelay3 eq "25" ) { our $selectedrelay3pin25 = "selected=selected" }


# Select GPIO Pin Relay 4
if ( $gpiorelay4 eq "4" ) { our $selectedrelay4pin4 = "selected=selected" }
elsif ( $gpiorelay4 eq "17" ) { our $selectedrelay4pin17 = "selected=selected" }
elsif ( $gpiorelay4 eq "18" ) { our $selectedrelay4pin18 = "selected=selected" }
elsif ( $gpiorelay4 eq "21" ) { our $selectedrelay4pin21 = "selected=selected" }
elsif ( $gpiorelay4 eq "22" ) { our $selectedrelay4pin22 = "selected=selected" }
elsif ( $gpiorelay4 eq "23" ) { our $selectedrelay4pin23 = "selected=selected" }
elsif ( $gpiorelay4 eq "24" ) { our $selectedrelay4pin24 = "selected=selected" }
elsif ( $gpiorelay4 eq "25" ) { our $selectedrelay4pin25 = "selected=selected" }




# Title
$template_title = "Relay Plugin";

# Create help page
$helptext = "";

print "Content-Type: text/html\n\n";

# Currently only german is supported - so overwrite user language settings:
$lang = "de";

# Load header and replace HTML Markup <!--$VARNAME--> with perl variable $VARNAME
open(F,"$installfolder/templates/system/$lang/header.html") || die "Missing template system/$lang/header.html";
  while (<F>) {
    $_ =~ s/<!--\$(.*?)-->/${$1}/g;
    print $_;
  }
close(F);



# Main
open(F,"$installfolder/templates/plugins/$psubfolder/$lang/main.html") || die "Missing template plugins/$psubfolder/$lang/main.html";
while (<F>) 
  {
    $_ =~ s/<!--\$(.*?)-->/${$1}/g;
    print $_;
  }
close(F);


# Everything from URL
foreach (split(/&/,$ENV{'QUERY_STRING'}))
{
  ($namef,$value) = split(/=/,$_,2);
  $namef =~ tr/+/ /;
  $namef =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $query{$namef} = $value;
}


if ( $query{'relaynumber'} ne "" ) {
  $relaynumber = $query{'relaynumber'};
  if ( $relaynumber !~ /[0-9]/ ) {
    print "Wrong relaynumber. Giving up.";
    exit;
  }
}


if ($relaynumber == 1) { $relaynumber = $gpiorelay1; }
if ($relaynumber == 2) { $relaynumber = $gpiorelay2; }
if ($relaynumber == 3) { $relaynumber = $gpiorelay3; }
if ($relaynumber == 4) { $relaynumber = $gpiorelay4; }


if ( $query{'command'} ne "" ) {
  $command = $query{'command'};
  if ( $command eq "on" ) {
    $command = "1";
  }
  if ( $command eq "off" ) {
    $command = "0";
  }
  $command = substr($command,0,1);
  if ( $command !~ /[0-9]/ ) {
    print "Wrong command. Giving up.";
    exit;
  }
}


if ( $query{'offdelay'} ne "" ) {
  $offdelay = $query{'offdelay'};
  if ( $offdelay !~ /[0-9]/ ) {
    print "Wrong offdelay. Giving up.";
    exit;
  }
  $offdelay = "mils $offdelay w $relaynumber 0";
}


if ($relaynumber > 0 && ($command == 0 || $command == 1)) {
	print "Befehl pigs w $relaynumber $command $offdelay gesendet!\n\n";
    $output = qx(pigs w $relaynumber $command $offdelay);
	print $output;
}

# Load footer and replace HTML Markup <!--$VARNAME--> with perl variable $VARNAME
open(F,"$installfolder/templates/system/$lang/footer.html") || die "Missing template system/$lang/header.html";
  while (<F>) {
    $_ =~ s/<!--\$(.*?)-->/${$1}/g;
    print $_;
  }
close(F);

exit;
